func_RSVD_SA_SIM_NS_BREAK <- function(dgp_y, season_period, max_r) {
  
  # dgp_y <- ts_berr ###
  # season_period <- 4 ###
  # max_r <- 3 ###
  
  num_period <- length(dgp_y)/season_period
  
  BIC_values_updated <- NULL
  BIC_values_old <- Inf
  
  potential_break <-c(0, 3:(num_period-3))
  
  model_candidates <- list()
  IC_old <- Inf
  
  for (num_r in 1:max_r){
    
   ### num_r = 2
    
    temp <- list()
    for (i in 1:num_r) temp[[i]] <- potential_break
    
    matrix_r_breaks <- as.matrix(expand.grid(temp))
    potential_r_breaks <- list()
    for (i in 1:nrow(matrix_r_breaks)) potential_r_breaks[[i]] <- matrix_r_breaks[i,]
    
    temp_rsvd_all <- mclapply(X = potential_r_breaks, 
                              FUN = "func_RSVD_R_BREAKS", 
                              dgp_y=dgp_y,
                              season_period=season_period,
                              mc.preschedule = TRUE,
                              mc.cores = detectCores())
    
    model_candidates[[num_r]] <- temp_rsvd_all[[which.min(sapply(temp_rsvd_all, FUN = function(x) {x$eval_break}, simplify = TRUE))]]
    
    IC_new <- model_candidates[[num_r]]$info_cri
    
    if (IC_new > IC_old) {
      final_r <- num_r-1
      break 
    } else {
      if (num_r < max_r){
        IC_old <- IC_new 
      } else {
        final_r <- num_r
      }
    }
    
    
  }
  
  output <- model_candidates[[final_r]]
  
}



